#include <bits/stdc++.h>
using namespace  std;

#define int long long

signed main() {
	cin.tie(0)->sync_with_stdio(0);
	int n, p; cin >> n >> p;

	map<tuple<int, int, int, int>, int> norm;
	map<int, int> horiz;
	
	vector<tuple<int, int>> points(n);
	for (auto &[x,y] : points) {
		cin >> x >> y;
		x *= 2;
		y *= 2;
	}

	for (int i = 0; i < n; i++) for(int j = 0; j < i;j++) {
		auto [ax, ay] = points[i];
		auto [bx, by] = points[j];
		if (ay < by) {
			swap(ay, by);
			swap(ax, bx);
		}

		if (ay == by) {
			horiz[(ax + bx) / 2]++;
		}else {
			int norm_x = by - ay;
			int norm_y = ax - bx;
			int y0_a = by*by - ay*ay - (ax*ax - bx*bx);
			int y0_b = 2*(by - ay);
			int g1 = gcd(abs(norm_x), abs(norm_y));
			int g2 = gcd(abs(y0_a), abs(y0_b));

			norm[{y0_a / g2, y0_b / g2, norm_x / g1, norm_y / g1}] ++;
		}
	}

	int mx = 0;
	for (auto [i, j] : norm) {
		auto [a, b, c, d] = i;
		// cerr << a << " " << b << " "<< c << " " << d << " : " << j << endl;
		mx = max(mx, j);
	}
	for (auto [i, j] : horiz) mx = max(mx, j);

	mx *= 2;


	cerr << mx << endl;
	if (mx * 100 >= n * p) {
		cout << "YES\n";
	}
	else {
		cout << "NO\n";
	}
} 
